
/**
  SCCP3 Generated Driver File 

  @Company
    Microchip Technology Inc.

  @File Name
    sccp3.c

  @Summary
    This is the generated driver implementation file for the SCCP3 driver using MPLAB(c) Code Configurator

  @Description
    This header file provides implementations for driver APIs for SCCP3. 
    Generation Information : 
        Product Revision  :  MPLAB(c) Code Configurator - 3.15.0
        Device            :  PIC32MM0064GPL036
        Driver Version    :  0.5
    The generated drivers are tested against the following:
        Compiler          :  XC32 1.40
        MPLAB             :  MPLAB X 3.20
*/

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

/**
  Section: Included Files
*/

#include <xc.h> 
#include "sccp3_tmr.h"
#include "pin_manager.h"
void  Key_Scan (void);

/**
  Section: Data Type Definitions
*/

/**
  SCCP3 Driver Hardware Instance Object

  @Summary
    Defines the object required for the maintenance of the hardware instance.

  @Description
    This defines the object required for the maintenance of the hardware
    instance. This object exists once per hardware instance of the peripheral.

*/
typedef struct _SCCP3_TMR_OBJ_STRUCT
{

    /* Timer Elapsed */
    bool                                                    primaryTimer16Elapsed;
    bool                                                    secondaryTimer16Elapsed;
    bool                                                    Timer32Elapsed;
} SCCP3_TMR_OBJ;

static SCCP3_TMR_OBJ sccp3_timer_obj;
void SCCP3_TMR_Initialize(void)
{
  //ON enabled; MOD 16-Bit/32-Bit Timer; ALTSYNC disabled; SIDL disabled; OPS Each Time Base Period Match; CCPSLP disabled; TMRSYNC disabled; RTRGEN disabled; CCSEL disabled; ONESHOT disabled; TRIGEN disabled; T32 16 Bit; SYNC None; OPSSRC Timer Interrupt Event; TMRPS 1:16; CLKSEL SYSCLK; 
    CCP3CON1 = 0x8080;
  //ASDGM disabled; ICGSM Level-Sensitive mode; ICS ICM3; SSDG disabled; AUXOUT Disabled; ASDG None; PWMRSEN disabled; OCAEN disabled; OENSYNC disabled; 
    CCP3CON2 = 0x0;
  //OETRIG disabled; OSCNT None; POLACE disabled; PSSACE Tri-state; 
    CCP3CON3 = 0x0;
  //SCEVT disabled; TRSET disabled; ICOV disabled; TMRHWIP disabled; ASEVT disabled; ICGARM disabled; RBWIP disabled; TMRLWIP disabled; TRCLR disabled; RAWIP disabled; PRLWIP disabled; 
    CCP3STAT = 0x0;
  //TMRL 0; TMRH 0; 
    CCP3TMR = 0x0;
  //PRH 0; PRL 4500; 
    CCP3PR = 0x1194;
  //CMPA 0; 
    CCP3RA = 0x0;
  //CMPB 0; 
    CCP3RB = 0x0;
  //BUFL 0; BUFH 0; 
    CCP3BUF = 0x0;

    IFS1CLR= 1 << _IFS1_CCP3IF_POSITION;

    IFS1CLR= 1 << _IFS1_CCT3IF_POSITION;
      
    // Enabling SCCP3 interrupt.
    IEC1bits.CCP3IE = 1;

    // Enabling SCCP3 interrupt.
    IEC1bits.CCT3IE = 1;

}

void SCCP3_TMR_Start( void )
{
    /* Reset the status information */
    sccp3_timer_obj.primaryTimer16Elapsed = false;
    sccp3_timer_obj.secondaryTimer16Elapsed = false;
    sccp3_timer_obj.Timer32Elapsed = false;

    /* Start the Timer */
    CCP3CON1bits.ON = true;
}
void SCCP3_TMR_Stop( void )
{
    /* Stop the Timer */
    CCP3CON1bits.ON = false;

}

void __attribute__ ( ( vector ( _CCT3_VECTOR ), interrupt ( IPL5SOFT ))) CCT3_ISR (void)
{
    /* Check if the Timer Interrupt/Status is set */
    if(IFS1bits.CCT3IF)
    {         
        sccp3_timer_obj.primaryTimer16Elapsed = true;
        IFS1CLR= 1 << _IFS1_CCT3IF_POSITION;
        IO_RB15_Toggle()   ;
         Key_Scan();
    }
}


void __attribute__ ( ( vector ( _CCP3_VECTOR ), interrupt ( IPL1SOFT ))) CCP3_ISR (void)
{
    /* Check if the Timer Interrupt/Status is set */
    if(IFS1bits.CCP3IF)
    {
        sccp3_timer_obj.secondaryTimer16Elapsed = true;
        IFS1CLR= 1 << _IFS1_CCP3IF_POSITION;
    }
}

void SCCP3_TMR_Period16BitPrimarySet( uint16_t value )
{
    /* Update the counter values */
    CCP3PRbits.PRL = value;

    /* Reset the status information */
    sccp3_timer_obj.primaryTimer16Elapsed = false;
}
void SCCP3_TMR_Period16BitSecondarySet( uint16_t value )
{
    /* Update the counter values */
    CCP3PRbits.PRH = value;

    /* Reset the status information */
    sccp3_timer_obj.secondaryTimer16Elapsed = false;
}
uint16_t SCCP3_TMR_Period16BitPrimaryGet( void )
{
    return CCP3PRbits.PRL;
}
uint16_t SCCP3_TMR_Period16BitSecondaryGet( void )
{
    return CCP3PRbits.PRH;
}
void SCCP3_TMR_Counter16BitPrimarySet ( uint16_t value )
{
    /* Update the counter values */
    CCP3PRbits.PRL = value;
    /* Reset the status information */
    sccp3_timer_obj.primaryTimer16Elapsed = false;
}
void SCCP3_TMR_Counter16BitSecondarySet ( uint16_t value )
{
    /* Update the counter values */
    CCP3PRbits.PRH = value;
    /* Reset the status information */
    sccp3_timer_obj.secondaryTimer16Elapsed = false;
}
uint16_t SCCP3_TMR_Counter16BitPrimaryGet( void )
{
    return CCP3TMRbits.TMRL;
}

uint16_t SCCP3_TMR_Counter16BitSecondaryGet( void )
{
    return CCP3TMRbits.TMRH;
}

bool SCCP3_TMR_PrimaryTimer16ElapsedThenClear(void)
{
    bool status;
    
    status = sccp3_timer_obj.primaryTimer16Elapsed ;
    
    if(status == true)
    {
        sccp3_timer_obj.primaryTimer16Elapsed = false;
    }
    return status;
}
bool SCCP3_TMR_SecondaryTimer16ElapsedThenClear(void)
{
    bool status;
    
    status = sccp3_timer_obj.secondaryTimer16Elapsed ;
    
    if(status == true)
    {
        sccp3_timer_obj.secondaryTimer16Elapsed = false;
    }
    return status;
}

/**
 End of File
*/